args <- commandArgs(trailingOnly = TRUE)

## reading data
d <- scan(args[2], what=" ", quiet=TRUE)
delta = 1+4*length(d)
n=(-1+sqrt(delta))/2
smat = t(matrix(d,n,n+1))[2:(n+1),]
labels = matrix(d,n,n+1)[,1]

## out-edges
mat = t(matrix( as.numeric(unlist(strsplit(apply(smat,1,paste, collapse = ''),""))), 3*n, n))
## in-edges
tmat = matrix(0,n,3*n)
for(i in 1:n){
    for(j in 1:n){
        for(k in 1:3){
            tmat[i, (3*(j-1))+k] = mat[j, (3*(i-1))+k]
        }
   }
}
## out+in edges
all = cbind(mat,tmat)

## distance as a sum of distance
options(warn=-1)
msg.trap <- capture.output( suppressMessages(require(ade4)) )
s=seq(1,2*n*3,by=3)
dst = ( dist.binary(all[,s], method = 4)^2 + dist.binary(all[,s+1], method = 4)^2 + dist.binary(all[,s+2], method = 4)^2 )


## kmeans to file
Qmin=as.numeric(args[3])
Qmax=as.numeric(args[4])
tempdir=args[5]
for (Q in Qmin:Qmax){
  km = kmeans(as.matrix(dst), Q, iter.max = 100, nstart = 10000)
  fname = paste(tempdir,"/kmeans_Q",Q,".groups",sep="")
  writeLines("# Colors", con=fname)
  write(t(cbind(labels, km$cluster-1)), file=fname, ncolumns=2, append=T)
}

