#ifndef MIXSNET_TRIPLET_HPP
#define MIXSNET_TRIPLET_HPP
#include<iostream>
#include<bitset>
#include<array>

namespace mixsnet{
  /*
    Binary coding from right to left :
    000  0
    100  4
    010  2
    110  6
    001  1
    101  5
    011  3
    111  7
   */
  const std::array<std::string, 8> STRTRIPLETS = { {"000", "001", "010", "011", "100", "101", "110", "111"} };

  class Triplet : private std::bitset<3>
  {
  public:
    Triplet() : std::bitset<3>() {}
    Triplet(std::string ts) : std::bitset<3>(ts) {}
    ~Triplet() {}
    bool operator[](size_t i) const {return (*this).std::bitset<3>::operator[](2-i);}
    unsigned int binary2int() const {return to_ulong();}
    friend std::istream& operator>>(std::istream& in, Triplet& t)
    {
      return std::operator>>(in, static_cast<std::bitset<3>&>(t));
    }
    friend std::ostream& operator<<(std::ostream& out, const Triplet& t)
    {
      return std::operator<<(out, static_cast<const std::bitset<3>&>(t));
    }
    Triplet& operator=(const Triplet& t){
      return static_cast<Triplet&>(
          bitset<3>::operator=(static_cast<const std::bitset<3>&>(t)) );
    }
    bool operator==(const Triplet& t){
      return bitset<3>::operator==(static_cast<const std::bitset<3>&>(t));
    }

  };

}
#endif
