#include<MixSNet.hpp>
#include<Bernouilli3DDistribution.hpp>
#include<Penalty.hpp>
#include<iostream>
#include<stdlib.h>
using namespace std;
using namespace mixsnet;
int main(int argc, char **argv)
{
  if (argc==1){
      cout<<argv[0]<<" <NETFILE> <OUTDATAFILE> <MODELFILE>"<<std::endl;
      exit(0);
  }
  if (argv[1][1] == 'h'){
      cout<<argv[0]<<" <NETFILE> <OUTDATAFILE> <MODELFILE>"<<std::endl;
      exit(0);
  }
  ColoredRoadNetwork<double> net(argv[1]);

  Bernouilli3D dist(0);

  MixSNet<double, Triplet, Bernouilli3D> model(net, dist);
  ifstream fin;
  fin.open(argv[3]);
  fin>>model;
  fin.close();
  std::cerr<<model;

  Matrix<Triplet> mat =  model.draw();
  mat.write(argv[2], net.getConvertToNameFunction());

  return 0;
}
