#include<Bernouilli3DDistribution.hpp>
#include<iostream>
#include<math.h>
#include<assert.h>
using namespace std;
using namespace placeholders;
using namespace mixsnet;
int main(int argc, char **argv)
{
  ColoredRoadNetwork<int> net(argv[1]);
  Matrix<Triplet> mat;
  mat.read(argv[2], net.getConvertToIndexFunction());
  std::cerr<<mat<<std::endl;

  Bernouilli3D dist(2);

  dist.compute(net, mat);
  std::cout<<"\n\nAttention SELF LOOPS\n\n"<<std::endl;
  std::cout<<dist;
  assert(abs(dist.getP3Dkql(0,0,0)-0.1875)<0.00001);
  assert(abs(dist.getP3Dkql(2,0,0)-0.125)<0.00001);
  assert(abs(dist.getP3Dkql(3,0,0)-0.125)<0.00001);
  assert(abs(dist.getP3Dkql(7,0,0)-0.1875)<0.00001);

  vector<Triplet> v;
  Triplet tref("101");
  int c=0;
  for (unsigned int i=0; i<100000; i++){
    Triplet tcur = dist.draw(0,0,0,0);
    if (tcur == tref){
        c++;
    }
  }
  assert(abs(c/100000.-0.1875)<0.01);


  net.setColor(net.getVertexByIndex(0), 1);
  dist.compute(net, mat);
  std::cout<<dist;

  return 0;
}
