#include<MixSNet.hpp>
#include<GaussianDistribution.hpp>
#include<Penalty.hpp>
#include<iostream>
#include <assert.h>
using namespace std;
using namespace mixsnet;
int main(int argc, char **argv)
{
  ColoredRoadNetwork<int> net(argv[1]);

  Matrix<double> mat;
  mat.read(argv[2], net.getConvertToIndexFunction());

  HomoscedasticGaussian dist(2);

  MixSNet<int, double, HomoscedasticGaussian> model(net, dist);
  model.setLambda(10);
  model.initialize(mat, 'R');
  model.estimate<NeighborhoodPenalty<int, SijProximity<int> > >(mat);
  std::cerr<<"Lkl: "<<model.completeLogLikelihood<NeighborhoodPenalty<int, SijProximity<int> > >(mat)<<std::endl;

  ofstream fout;
  fout.open("testMixSNet.out");
  fout<<model;
  fout.close();
  ifstream fin;
  fin.open("testMixSNet.out");
  fin>>model;
  fin.close();

  return 0;
}
