#include<MixSNet.hpp>
#include<GaussianDistribution.hpp>
#include<Penalty.hpp>
#include<iostream>
#include <assert.h>
using namespace std;
using namespace mixsnet;
int main(int argc, char **argv)
{
  ColoredRoadNetwork<int> net(argv[1]);

  Matrix<double> mat;
  mat.read(argv[2], net.getConvertToIndexFunction());

  InflatedDistribution<HomoscedasticGaussian> dist(2, 1.);

  MixSNet<int, double, InflatedDistribution<HomoscedasticGaussian> > model(net, dist);
  model.setLambda(10);
  model.initialize(mat);
  assert(abs(dist.getBetaql(1,0)-(2/3.))<0.000001);
  model.estimate<NeighborhoodPenalty<int, SijProximity<int> > >(mat);
  std::cerr<<"Lkl: "<<model.completeLogLikelihood<NeighborhoodPenalty<int, SijProximity<int> > >(mat)<<std::endl;
  assert(abs(dist.getSigma2ql(1,1)-0.0288889)<0.0001);

  ofstream fout;
  fout.open("testMixSNetInflated.out");
  fout<<model;
  fout.close();
  ifstream fin;
  fin.open("testMixSNetInflated.out");
  fin>>model;
  fin.close();

  return 0;
}
