#include<OMPConductor.hpp>
#include<GaussianDistribution.hpp>
#include<iostream>
#include <assert.h>
using namespace std;
using namespace mixsnet;
int main(int argc, char **argv)
{
  ColoredRoadNetwork<unsigned int> net(argv[1]);

  Matrix<double> mat;
  mat.read(argv[2], net.getConvertToIndexFunction());

  HomoscedasticGaussian dist(atoi(argv[3]));

  OMPConductor<unsigned int, double, HomoscedasticGaussian> runner;
  runner.activateHclust();
  runner.activateSpatial();
  runner.activateRandom(100);
  runner.setBurnNbIteration(0);
  //runner.pipeline<NeighborhoodPenalty<unsigned int, SijLaplacian<unsigned int> > >(atoi(argv[3]), net, mat);
  runner.pipeline<NeighborhoodPenalty<unsigned int, SijProximity<unsigned int> > >( net, dist, mat, 3., 0.5);

  return 0;
}
